import React from 'react';
import type { SlideTransitionProps, FadeTransitionProps } from 'ark-transition';
export declare type DrawerOnChange = (value: boolean) => void;
export interface DrawerProps {
    /** 内容transition组件参数 */
    transition?: SlideTransitionProps;
    /** 蒙层transition组件参数 */
    maskTransition?: FadeTransitionProps;
    /** 类名 */
    className?: string;
    /** 样式 */
    style?: React.CSSProperties;
    /** 蒙层类名 */
    maskClassName?: string;
    /** 蒙层样式 */
    maskStyle?: React.CSSProperties;
    /** 内容 */
    children?: React.ReactNode;
    /** 状态（若为true，则是呈现态，否则是隐藏态） */
    value?: boolean;
    /** 内容宽度或高度 */
    size?: React.CSSProperties['width'];
    /** 方向 */
    direction?: SlideTransitionProps['direction'];
    /** 改变已选值 */
    onChange?: DrawerOnChange;
}
export interface DrawerRef {
    /** 根节点 */
    rootNode: HTMLDivElement | null;
}
export declare const Drawer: React.ForwardRefExoticComponent<DrawerProps & React.RefAttributes<DrawerRef>>;
