"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Drawer = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _drawer = _interopRequireDefault(require("./drawer.scss"));

var _arkTransition = require("ark-transition");

var _excluded = ["transition", "maskTransition", "className", "maskClassName", "maskStyle", "children", "value", "size", "direction", "onChange"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var DIR_STYLES = {
  top: _drawer["default"].top,
  right: _drawer["default"].right,
  bottom: _drawer["default"].bottom,
  left: _drawer["default"].left
};
var Drawer = /*#__PURE__*/(0, _react.forwardRef)(function (_ref, ref) {
  var transition = _ref.transition,
      maskTransition = _ref.maskTransition,
      className = _ref.className,
      maskClassName = _ref.maskClassName,
      maskStyle = _ref.maskStyle,
      children = _ref.children,
      value = _ref.value,
      size = _ref.size,
      direction = _ref.direction,
      onChange = _ref.onChange,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  var rootRef = (0, _react.useRef)(null);
  var dir = direction || 'bottom';
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      rootNode: rootRef.current
    };
  }, [rootRef.current]);
  var style = props.style || {};

  if ('lr'.includes(dir[0])) {
    style.width = size;
  } else {
    style.height = size;
  }

  return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_arkTransition.FadeTransition, (0, _extends2["default"])({}, maskTransition, {
    value: value
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(maskClassName, _drawer["default"].xrdrawermask),
    style: maskStyle,
    onClick: function onClick() {
      if (onChange) {
        onChange(false);
      }
    }
  })), /*#__PURE__*/_react["default"].createElement(_arkTransition.SlideTransition, (0, _extends2["default"])({}, transition, {
    value: value,
    direction: dir
  }), /*#__PURE__*/_react["default"].createElement("div", {
    ref: rootRef,
    style: style,
    className: (0, _classnames["default"])(className, _drawer["default"].xrdrawerconent, DIR_STYLES[dir])
  }, children)));
});
exports.Drawer = Drawer;