import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["transition", "maskTransition", "className", "maskClassName", "maskStyle", "children", "value", "size", "direction", "onChange"];
import React, { forwardRef, useRef, useImperativeHandle, Fragment } from 'react';
import cn from 'classnames';
import styles from './drawer.scss';
import { SlideTransition, FadeTransition } from 'ark-transition';
var DIR_STYLES = {
  top: styles.top,
  right: styles.right,
  bottom: styles.bottom,
  left: styles.left
};
export var Drawer = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var transition = _ref.transition,
      maskTransition = _ref.maskTransition,
      className = _ref.className,
      maskClassName = _ref.maskClassName,
      maskStyle = _ref.maskStyle,
      children = _ref.children,
      value = _ref.value,
      size = _ref.size,
      direction = _ref.direction,
      onChange = _ref.onChange,
      props = _objectWithoutProperties(_ref, _excluded);

  var rootRef = useRef(null);
  var dir = direction || 'bottom';
  useImperativeHandle(ref, function () {
    return {
      rootNode: rootRef.current
    };
  }, [rootRef.current]);
  var style = props.style || {};

  if ('lr'.includes(dir[0])) {
    style.width = size;
  } else {
    style.height = size;
  }

  return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(FadeTransition, _extends({}, maskTransition, {
    value: value
  }), /*#__PURE__*/React.createElement("div", {
    className: cn(maskClassName, styles.xrdrawermask),
    style: maskStyle,
    onClick: function onClick() {
      if (onChange) {
        onChange(false);
      }
    }
  })), /*#__PURE__*/React.createElement(SlideTransition, _extends({}, transition, {
    value: value,
    direction: dir
  }), /*#__PURE__*/React.createElement("div", {
    ref: rootRef,
    style: style,
    className: cn(className, styles.xrdrawerconent, DIR_STYLES[dir])
  }, children)));
});